// IndicatorTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IndicatorTest.h"
#include "IndicatorTestDlg.h"
#include ".\indicatortestdlg.h"
#include "indicator.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIndicatorTestDlg dialog

CIndicatorTestDlg::CIndicatorTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIndicatorTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIndicatorTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CIndicatorTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIndicatorTestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CIndicatorTestDlg, CDialog)
	//{{AFX_MSG_MAP(CIndicatorTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ONBUTTON1, OnOnbutton1)
	ON_BN_CLICKED(IDC_OFFBUTTON1, OnOffbutton1)
	ON_BN_CLICKED(IDC_LOADBUTTON1, OnLoadbutton1)
	ON_BN_CLICKED(IDC_RUNBUTTON1, OnRunbutton1)
	ON_BN_CLICKED(IDC_STOPBUTTON1, OnStopbutton1)
	ON_WM_TIMER()
	ON_WM_CANCELMODE()
	ON_BN_CLICKED(IDC_STYLE2, OnStyle2)
	ON_BN_CLICKED(IDC_STYLE3, OnStyle3)
	ON_BN_CLICKED(IDC_STYLE1, OnStyle1)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_ONBUTTON2, OnOnbutton2)
	ON_BN_CLICKED(IDC_OFFBUTTON2, OnOffbutton2)
	ON_BN_CLICKED(IDC_LOADBUTTON2, OnLoadbutton2)
	ON_BN_CLICKED(IDC_RUNBUTTON2, OnRunbutton2)
	ON_BN_CLICKED(IDC_STOPBUTTON2, OnStopbutton2)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIndicatorTestDlg message handlers

BOOL CIndicatorTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	indicator1.LoadBitMapImage (IDB_BITMAP2, 0);
	indicator1.LoadBitMapImage (IDB_BITMAP1, 1);
	indicator1.LoadBitMapImage (IDB_BITMAP1, 2);
	indicator1.LoadBitMapImage (IDB_BITMAP1, 3);

	indicator1.LoadString ("Off", 0);
	indicator1.LoadString ("Ready", 1);
	indicator1.LoadString ("Loading", 2);
	indicator1.LoadString ("Running", 3);

	indicator1.m_nState = 0;
	indicator1.ChangeIndicatorStyle (IND_STYLE_USE_BITMAP, TRUE);

	indicator2.LoadBitMapImage (IDB_BITMAP2, 0);
	indicator2.LoadBitMapImage (IDB_BITMAP1, 1);
	indicator2.LoadString ("On", 0);
	indicator2.LoadString ("On", 1);
	indicator2.m_nState = 0;
	indicator3.LoadBitMapImage (IDB_BITMAP2, 0);
	indicator3.LoadBitMapImage (IDB_BITMAP1, 1);
	indicator3.LoadString ("Ready", 0);
	indicator3.LoadString ("Ready", 1);
	indicator3.m_nState = 0;
	indicator4.LoadBitMapImage (IDB_BITMAP2, 0);
	indicator4.LoadBitMapImage (IDB_BITMAP1, 1);
	indicator4.LoadString ("Loading", 0);
	indicator4.LoadString ("Loading", 1);
	indicator4.m_nState = 0;
	indicator5.LoadBitMapImage (IDB_BITMAP2, 0);
	indicator5.LoadBitMapImage (IDB_BITMAP1, 1);
	indicator5.LoadString ("Running", 0);
	indicator5.LoadString ("Running", 1);
	indicator5.m_nState = 0;

	style_i1.LoadBitMapImage (IDB_BITMAP1, 0);
	style_i2.LoadBitMapImage (IDB_BITMAP2, 0);
	style_i3.LoadBitMapImage (IDB_BITMAP3, 0);
	style_i4.LoadBitMapImage (IDB_BITMAP4, 0);
	style_i5.LoadBitMapImage (IDB_BITMAP5, 0);
	style_i6.LoadBitMapImage (IDB_BITMAP6, 0);

	style_i1.LoadString ("On", 0);
	style_i2.LoadString ("Off", 0);
	style_i3.LoadString ("On", 0);
	style_i4.LoadString ("Off", 0);
	style_i5.LoadString ("On", 0);
	style_i6.LoadString ("Off", 0);

	style_i1.m_nState = 0;
	style_i2.m_nState = 0;
	style_i3.m_nState = 0;
	style_i4.m_nState = 0;
	style_i5.m_nState = 0;
	style_i6.m_nState = 0;

	GetDlgItem (IDC_ONBUTTON1) -> EnableWindow  (TRUE);
	GetDlgItem (IDC_OFFBUTTON1) -> EnableWindow (FALSE);
	GetDlgItem (IDC_LOADBUTTON1) -> EnableWindow (FALSE);
	GetDlgItem (IDC_RUNBUTTON1) -> EnableWindow (FALSE);
	GetDlgItem (IDC_STOPBUTTON1) -> EnableWindow (FALSE);
	GetDlgItem (IDC_ONBUTTON2) -> EnableWindow  (TRUE);
	GetDlgItem (IDC_OFFBUTTON2) -> EnableWindow (FALSE);
	GetDlgItem (IDC_LOADBUTTON2) -> EnableWindow (FALSE);
	GetDlgItem (IDC_RUNBUTTON2) -> EnableWindow (FALSE);
	GetDlgItem (IDC_STOPBUTTON2) -> EnableWindow (FALSE);

	CheckRadioButton (IDC_STYLE1, IDC_STYLE3, IDC_STYLE1);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CIndicatorTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDC* dc;
		dc = GetDC ();
		CDialog::OnPaint();

		CRect ind1_bounds (25, 25, 450, 100);
		indicator1.Draw (dc, ind1_bounds);

		CRect ind2_bounds (25, 175, 237, 212);
		indicator2.Draw (dc, ind2_bounds);
		CRect ind3_bounds (25, 213, 237, 250);
		indicator3.Draw (dc, ind3_bounds);
		CRect ind4_bounds (238, 175, 450, 212);
		indicator4.Draw (dc, ind4_bounds);
		CRect ind5_bounds (238, 213, 450, 250);
		indicator5.Draw (dc, ind5_bounds);

		CRect s1_bounds (25, 330, 160, 370);
		style_i1.Draw (dc, s1_bounds);
		CRect s2_bounds (25, 380, 160, 420);
		style_i2.Draw (dc, s2_bounds);

		CRect s3_bounds (170, 330, 305, 370);
		style_i3.Draw (dc, s3_bounds);
		CRect s4_bounds (170, 380, 305, 420);
		style_i4.Draw (dc, s4_bounds);

		CRect s5_bounds (315, 330, 450, 370);
		style_i5.Draw (dc, s5_bounds);
		CRect s6_bounds (315, 380, 450, 420);
		style_i6.Draw (dc, s6_bounds);

	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIndicatorTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CIndicatorTestDlg::OnOnbutton1() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem (IDC_ONBUTTON1) -> EnableWindow  (FALSE);
	GetDlgItem (IDC_OFFBUTTON1) -> EnableWindow (TRUE);
	GetDlgItem (IDC_LOADBUTTON1) -> EnableWindow (TRUE);
	GetDlgItem (IDC_RUNBUTTON1) -> EnableWindow (TRUE);
	GetDlgItem (IDC_STOPBUTTON1) -> EnableWindow (FALSE);

	
	indicator1.m_nState = 1;
	Invalidate (TRUE);
}

void CIndicatorTestDlg::OnOffbutton1() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem (IDC_ONBUTTON1) -> EnableWindow  (TRUE);
	GetDlgItem (IDC_OFFBUTTON1) -> EnableWindow (FALSE);
	GetDlgItem (IDC_LOADBUTTON1) -> EnableWindow (FALSE);
	GetDlgItem (IDC_RUNBUTTON1) -> EnableWindow (FALSE);
	GetDlgItem (IDC_STOPBUTTON1) -> EnableWindow (FALSE);

	indicator1.m_nState = 0;
	Invalidate (TRUE);
}

void CIndicatorTestDlg::OnLoadbutton1() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem (IDC_ONBUTTON1) -> EnableWindow  (FALSE);
	GetDlgItem (IDC_OFFBUTTON1) -> EnableWindow (FALSE);
	GetDlgItem (IDC_LOADBUTTON1) -> EnableWindow (FALSE);
	GetDlgItem (IDC_RUNBUTTON1) -> EnableWindow (FALSE);
	GetDlgItem (IDC_STOPBUTTON1) -> EnableWindow (FALSE);
	
	indicator1.m_nState = 2;
	Invalidate (TRUE);
	SetTimer (1, 3000, NULL);
}



void CIndicatorTestDlg::OnRunbutton1() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem (IDC_ONBUTTON1) -> EnableWindow  (FALSE);
	GetDlgItem (IDC_OFFBUTTON1) -> EnableWindow (FALSE);
	GetDlgItem (IDC_LOADBUTTON1) -> EnableWindow (FALSE);
	GetDlgItem (IDC_RUNBUTTON1) -> EnableWindow (FALSE);
	GetDlgItem (IDC_STOPBUTTON1) -> EnableWindow (TRUE);
	
	indicator1.m_nState = 3;
	Invalidate (TRUE);
}



void CIndicatorTestDlg::OnStopbutton1() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem (IDC_ONBUTTON1) -> EnableWindow  (FALSE);
	GetDlgItem (IDC_OFFBUTTON1) -> EnableWindow (TRUE);
	GetDlgItem (IDC_LOADBUTTON1) -> EnableWindow (TRUE);
	GetDlgItem (IDC_RUNBUTTON1) -> EnableWindow (TRUE);
	GetDlgItem (IDC_STOPBUTTON1) -> EnableWindow (FALSE);
	
	indicator1.m_nState = 1;
	Invalidate (TRUE);
}

void CIndicatorTestDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnTimer(nIDEvent);

	if (nIDEvent == 1)
	{
		KillTimer (1);
		GetDlgItem (IDC_ONBUTTON1) -> EnableWindow  (FALSE);
		GetDlgItem (IDC_OFFBUTTON1) -> EnableWindow (TRUE);
		GetDlgItem (IDC_LOADBUTTON1) -> EnableWindow (TRUE);
		GetDlgItem (IDC_RUNBUTTON1) -> EnableWindow (TRUE);
		GetDlgItem (IDC_STOPBUTTON1) -> EnableWindow (FALSE);
		
		indicator1.m_nState = 1;
		Invalidate (TRUE);
	}

	if (nIDEvent == 2)
	{
		KillTimer (2);
		GetDlgItem (IDC_ONBUTTON2) -> EnableWindow  (FALSE);
		GetDlgItem (IDC_OFFBUTTON2) -> EnableWindow (TRUE);
		GetDlgItem (IDC_LOADBUTTON2) -> EnableWindow (TRUE);
		GetDlgItem (IDC_RUNBUTTON2) -> EnableWindow (TRUE);
		GetDlgItem (IDC_STOPBUTTON2) -> EnableWindow (FALSE);
		
		indicator4.m_nState = 0;
		indicator3.m_nState = 1;
		Invalidate (TRUE);
	}
}

void CIndicatorTestDlg::OnCancelMode() 
{
	CDialog::OnCancelMode();
	
	// TODO: Add your message handler code here
	
}

void CIndicatorTestDlg::OnOnbutton2()
{
	// TODO: Add your control notification handler code here
	GetDlgItem (IDC_ONBUTTON2) -> EnableWindow  (FALSE);
	GetDlgItem (IDC_OFFBUTTON2) -> EnableWindow (TRUE);
	GetDlgItem (IDC_LOADBUTTON2) -> EnableWindow (TRUE);
	GetDlgItem (IDC_RUNBUTTON2) -> EnableWindow (TRUE);
	GetDlgItem (IDC_STOPBUTTON2) -> EnableWindow (FALSE);
	
	indicator2.m_nState = 1;
	indicator3.m_nState = 1;

	Invalidate (TRUE);
}

void CIndicatorTestDlg::OnOffbutton2()
{
	// TODO: Add your control notification handler code here
	GetDlgItem (IDC_ONBUTTON2) -> EnableWindow  (TRUE);
	GetDlgItem (IDC_OFFBUTTON2) -> EnableWindow (FALSE);
	GetDlgItem (IDC_LOADBUTTON2) -> EnableWindow (FALSE);
	GetDlgItem (IDC_RUNBUTTON2) -> EnableWindow (FALSE);
	GetDlgItem (IDC_STOPBUTTON2) -> EnableWindow (FALSE);

	indicator2.m_nState = 0;
	indicator3.m_nState = 0;
	indicator4.m_nState = 0;
	indicator5.m_nState = 0;

	Invalidate (TRUE);
}

void CIndicatorTestDlg::OnLoadbutton2()
{
	// TODO: Add your control notification handler code here
	GetDlgItem (IDC_ONBUTTON2) -> EnableWindow  (FALSE);
	GetDlgItem (IDC_OFFBUTTON2) -> EnableWindow (FALSE);
	GetDlgItem (IDC_LOADBUTTON2) -> EnableWindow (FALSE);
	GetDlgItem (IDC_RUNBUTTON2) -> EnableWindow (FALSE);
	GetDlgItem (IDC_STOPBUTTON2) -> EnableWindow (FALSE);
	
	indicator4.m_nState = 1;
	indicator3.m_nState = 0;
	Invalidate (TRUE);
	SetTimer (2, 3000, NULL);
}

void CIndicatorTestDlg::OnRunbutton2()
{
	// TODO: Add your control notification handler code here
	GetDlgItem (IDC_ONBUTTON2) -> EnableWindow  (FALSE);
	GetDlgItem (IDC_OFFBUTTON2) -> EnableWindow (FALSE);
	GetDlgItem (IDC_LOADBUTTON2) -> EnableWindow (FALSE);
	GetDlgItem (IDC_RUNBUTTON2) -> EnableWindow (FALSE);
	GetDlgItem (IDC_STOPBUTTON2) -> EnableWindow (TRUE);
	
	indicator3.m_nState = 0;
	indicator5.m_nState = 1;

	Invalidate (TRUE);
}

void CIndicatorTestDlg::OnStopbutton2()
{
	// TODO: Add your control notification handler code here
	GetDlgItem (IDC_ONBUTTON2) -> EnableWindow  (FALSE);
	GetDlgItem (IDC_OFFBUTTON2) -> EnableWindow (TRUE);
	GetDlgItem (IDC_LOADBUTTON2) -> EnableWindow (TRUE);
	GetDlgItem (IDC_RUNBUTTON2) -> EnableWindow (TRUE);
	GetDlgItem (IDC_STOPBUTTON2) -> EnableWindow (FALSE);
	
	indicator5.m_nState = 0;
	indicator3.m_nState = 1;
	Invalidate (TRUE);

}

void CIndicatorTestDlg::OnStyle2() 
{
	// TODO: Add your control notification handler code here
	indicator2.LoadBitMapImage (IDB_BITMAP4, 0);
	indicator2.LoadBitMapImage (IDB_BITMAP3, 1);
	indicator3.LoadBitMapImage (IDB_BITMAP4, 0);
	indicator3.LoadBitMapImage (IDB_BITMAP3, 1);
	indicator4.LoadBitMapImage (IDB_BITMAP4, 0);
	indicator4.LoadBitMapImage (IDB_BITMAP3, 1);
	indicator5.LoadBitMapImage (IDB_BITMAP4, 0);
	indicator5.LoadBitMapImage (IDB_BITMAP3, 1);
	Invalidate ();
}

void CIndicatorTestDlg::OnStyle3() 
{
	// TODO: Add your control notification handler code here
	indicator2.LoadBitMapImage (IDB_BITMAP6, 0);
	indicator2.LoadBitMapImage (IDB_BITMAP5, 1);
	indicator3.LoadBitMapImage (IDB_BITMAP6, 0);
	indicator3.LoadBitMapImage (IDB_BITMAP5, 1);
	indicator4.LoadBitMapImage (IDB_BITMAP6, 0);
	indicator4.LoadBitMapImage (IDB_BITMAP5, 1);
	indicator5.LoadBitMapImage (IDB_BITMAP6, 0);
	indicator5.LoadBitMapImage (IDB_BITMAP5, 1);
	Invalidate ();
}

void CIndicatorTestDlg::OnStyle1() 
{
	// TODO: Add your control notification handler code here
	indicator2.LoadBitMapImage (IDB_BITMAP2, 0);
	indicator2.LoadBitMapImage (IDB_BITMAP1, 1);
	indicator3.LoadBitMapImage (IDB_BITMAP2, 0);
	indicator3.LoadBitMapImage (IDB_BITMAP1, 1);
	indicator4.LoadBitMapImage (IDB_BITMAP2, 0);
	indicator4.LoadBitMapImage (IDB_BITMAP1, 1);
	indicator5.LoadBitMapImage (IDB_BITMAP2, 0);
	indicator5.LoadBitMapImage (IDB_BITMAP1, 1);
	Invalidate ();
}
